--[[
on_gui_switch_state_changed will not fires
after loading game when clicking the switch
that has left visible when saved before.
--]]

script.on_event(defines.events.on_gui_switch_state_changed, function(event)
  if not event.element then game.print{"",'no elem ',game.ticks_played} return end
  local switch = event.element.switch_state
  game.print({"",'switch_state = ',switch,' ',game.ticks_played},{math.random(),math.random(),math.random(),1})
end)

--initial frame will be shown always
script.on_event(defines.events.on_player_created, function(event)
  local player = game.players[event.player_index]
  local frame = player.gui.screen.add{type = 'frame', caption = 'test', name = 'frame1'}
  frame.add{type = 'button', name = 'btn1', caption = 'toggle switch window (btn1)'}
  frame.location = {100,100}
  local label = frame.add{type = 'label', caption = [[
[font=default-bold]on_gui_switch_state_changed[/font]
will not fires after loading game when clicking the switch
that has left visible when saved before.

1. Open switch window and click switch few times to see message.
2. Save the game while leaving switch window opened
3. Load the game and try to click switch
4. Toggle to refresh switch window, and try again.
   Then, it will become normal.
  ]]}
  label.style.single_line = false
  frame.add{type = 'button', name = 'btn2', caption = 'toggle switch remotely (btn2)'}
end)

--switch frame control
script.on_event(defines.events.on_gui_click, function(event)
  local player = game.players[event.player_index]
  if event.element and event.element.name == 'btn1' then
    if player.gui.screen.switchframe and player.gui.screen.switchframe.valid then
      player.gui.screen.switchframe.destroy()
      return
    end
    local frame = player.gui.screen.add{type = 'frame', caption = 'switch is here', name = 'switchframe'}
    frame.add{type = 'switch', name = 'THE_SWITCH', switch_state = 'none', allow_none_state = true,
    left_label_caption = 'LEFT', right_label_caption = 'RIGHT', tooltip = 'click me to see message'}
    frame.auto_center = true
  elseif event.element and event.element.name == 'btn2' then
    local frame = player.gui.screen.switchframe
    if frame and frame.valid then
      if frame.THE_SWITCH.switch_state == 'left' then frame.THE_SWITCH.switch_state = 'none'
      elseif frame.THE_SWITCH.switch_state == 'none' then frame.THE_SWITCH.switch_state = 'right'
      elseif frame.THE_SWITCH.switch_state == 'right' then frame.THE_SWITCH.switch_state = 'left'
      end
    end
  end
end)